=== debian/changelog ===
sysrepo (4.2.10-1) experimental; urgency=medium

  * New upstream version 4.2.10
  * Build libsysrepo8 with libyang4

 -- Bastian Germann <bage@debian.org>  Fri, 02 Jan 2026 19:03:06 +0100
