=== debian/control ===
Source: sysrepo
Section: libs
Maintainer: Bastian Germann <bage@debian.org>
Priority: optional
Standards-Version: 4.7.2
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libyang-dev (>= 4),
 pkgconf,
Build-Depends-Indep:
 doxygen <!nodoc>,
 graphviz <!nodoc>,
Build-Depends-Arch:
 libcmocka-dev <!nocheck>,
 libsystemd-dev,
 systemd-dev | systemd (<< 253-2~),
Homepage: https://github.com/sysrepo/sysrepo

Package: sysrepo
Depends: libsysrepo8 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: admin
Architecture: any
Multi-Arch: foreign
Description: YANG-based configuration and operational state data store [tools]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the tools to work with schemas and configuration.

Package: sysrepo-doc
Depends: ${misc:Depends}
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Description: YANG-based configuration and operational state data store [docs]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the documentation.

Package: sysrepo-plugind
Depends: libsysrepo8 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: admin
Architecture: any
Multi-Arch: foreign
Description: YANG-based configuration and operational state data store [daemon]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the daemon for grouping sysrepo plugins.

Package: sysrepo-modules
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: YANG-based configuration and operational state data store [YANG modules]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains several YANG modules.

Package: libsysrepo8
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
         sysrepo-modules
Architecture: any
Multi-Arch: same
Description: YANG-based configuration and operational state data store [C library]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the shared C library.

Package: libsysrepo-dev
Depends: libsysrepo8 (= ${binary:Version}),
         libyang-dev,
         ${misc:Depends},
Section: libdevel
Architecture: any
Multi-Arch: same
Description: YANG-based configuration and operational state data store [C development]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the C headers.
