## sysrepo 4.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -54,23 +54,23 @@
 # minor version changes with added functionality (new tool, functionality of the tool or library, ...) and
 # micro version is changed with a set of small changes or bugfixes anywhere in the project.
 set(SYSREPO_MAJOR_VERSION 4)
-set(SYSREPO_MINOR_VERSION 2)
-set(SYSREPO_MICRO_VERSION 10)
+set(SYSREPO_MINOR_VERSION 5)
+set(SYSREPO_MICRO_VERSION 1)
 set(SYSREPO_VERSION ${SYSREPO_MAJOR_VERSION}.${SYSREPO_MINOR_VERSION}.${SYSREPO_MICRO_VERSION})
 
 # Version of the library
 # Major version is changed with every backward non-compatible API/ABI change, minor version changes
 # with backward compatible change and micro version is connected with any internal change of the library.
 set(SYSREPO_MAJOR_SOVERSION 8)
-set(SYSREPO_MINOR_SOVERSION 2)
-set(SYSREPO_MICRO_SOVERSION 10)
+set(SYSREPO_MINOR_SOVERSION 4)
+set(SYSREPO_MICRO_SOVERSION 5)
 set(SYSREPO_SOVERSION_FULL ${SYSREPO_MAJOR_SOVERSION}.${SYSREPO_MINOR_SOVERSION}.${SYSREPO_MICRO_SOVERSION})
 set(SYSREPO_SOVERSION ${SYSREPO_MAJOR_SOVERSION})
 
 # Version of libyang library that this sysrepo depends on
-set(LIBYANG_DEP_VERSION 4.2.0)
-set(LIBYANG_DEP_SOVERSION 4.2.0)
-set(LIBYANG_DEP_SOVERSION_MAJOR 4)
+set(LIBYANG_DEP_VERSION 5.0.0)
+set(LIBYANG_DEP_SOVERSION 5.0.0)
+set(LIBYANG_DEP_SOVERSION_MAJOR 5)
 
 # generate only version header, it is needed for docs
 configure_file("${PROJECT_SOURCE_DIR}/src/version.h.in" "${PROJECT_BINARY_DIR}/include/sysrepo/version.h" ESCAPE_QUOTES @ONLY)
