=== debian/changelog ===
sysrepo (4.5.1-1) experimental; urgency=medium

  * New upstream version 4.5.1

 -- Bastian Germann <bage@debian.org>  Mon, 09 Feb 2026 15:18:23 +0100
