=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# be strict when comparing symbols
export DPKG_GENSYMBOLS_CHECK_LEVEL=4

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure -- -DSYSREPO_UMASK=002 -DCMAKE_BUILD_TYPE=RelWithDebInfo -DNACM_SRMON_DATA_PERM=660 -DSYSREPO_GROUP=sysrepo

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
override_dh_auto_build-indep:
	dh_auto_build -- doc
endif

override_dh_auto_install-indep:

execute_after_dh_installinit:
	dh_installsysusers
