## sysrepo 4.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 # micro version is changed with a set of small changes or bugfixes anywhere in the project.
 set(SYSREPO_MAJOR_VERSION 4)
 set(SYSREPO_MINOR_VERSION 5)
-set(SYSREPO_MICRO_VERSION 1)
+set(SYSREPO_MICRO_VERSION 3)
 set(SYSREPO_VERSION ${SYSREPO_MAJOR_VERSION}.${SYSREPO_MINOR_VERSION}.${SYSREPO_MICRO_VERSION})
 
 # Version of the library
@@ -63,13 +63,13 @@
 # with backward compatible change and micro version is connected with any internal change of the library.
 set(SYSREPO_MAJOR_SOVERSION 8)
 set(SYSREPO_MINOR_SOVERSION 4)
-set(SYSREPO_MICRO_SOVERSION 5)
+set(SYSREPO_MICRO_SOVERSION 7)
 set(SYSREPO_SOVERSION_FULL ${SYSREPO_MAJOR_SOVERSION}.${SYSREPO_MINOR_SOVERSION}.${SYSREPO_MICRO_SOVERSION})
 set(SYSREPO_SOVERSION ${SYSREPO_MAJOR_SOVERSION})
 
 # Version of libyang library that this sysrepo depends on
-set(LIBYANG_DEP_VERSION 5.0.0)
-set(LIBYANG_DEP_SOVERSION 5.0.0)
+set(LIBYANG_DEP_VERSION 5.0.8)
+set(LIBYANG_DEP_SOVERSION 5.0.8)
 set(LIBYANG_DEP_SOVERSION_MAJOR 5)
 
 # generate only version header, it is needed for docs
@@ -168,7 +168,8 @@
 # sr_cond implementation
 if(NOT SR_COND_IMPL)
     check_include_file("linux/futex.h" HAS_FUTEX)
-    if(HAS_FUTEX)
+    check_symbol_exists(SYS_futex "sys/syscall.h" HAS_SYS_FUTEX)
+    if(HAS_FUTEX AND HAS_SYS_FUTEX)
         set(SR_COND_IMPL "sr_cond_futex")
     else()
         set(SR_COND_IMPL "sr_cond_pthread")
@@ -236,5 +237,3 @@
 endif()
 message(STATUS "SRPD plugins path:  ${SRPD_PLUGINS_PATH}")
 
-if(NOT SYSREPOCFG_DEFAULT_LYD_FORMAT)
-    set(SYSREPOCFG_DEFAULT_LYD_FORMAT LYD_XML)
