=== debian/changelog ===
sysrepo (4.5.3-1) experimental; urgency=medium

  * New upstream version 4.5.3

 -- Bastian Germann <bage@debian.org>  Mon, 02 Mar 2026 13:16:16 +0100
